
{-# LANGUAGE Arrows, NoMonomorphismRestriction #-}
import ShadowLibrary.Core

import Text.XML.HXT.Core
import Text.XML.HXT.XPath
-- import Text.XML.HXT.Curl
import Data.List
import Data.List.Utils (replace)

import Text.Regex.Posix
import Text.Printf



-- extractRecords = extractLinks "//a[@class='action' and text() = 'View Journal']"
--                     >>> arr ((++"/issue/archive") . init)
--                     >>> extractLinksWithText "//div/h4[contains(@class, 'Vol')]/a"

extractRecords = extractLinksWithText "//a[@class='action' and text() = 'View Journal']"  -- pary adres-tytuł
                 >>> second (arr $ replace "\r\n            " " ") -- czyścimy drugi element pary, czyli tytuł z niepotrzebnych białych znaków
                 >>> first (arr ((++"/issue/archive") . init))  -- modyfikujemy pierwszy element pary, czyli adres URL
                 >>> first (extractLinksWithText "//div/h4[contains(@class, 'Vol')]/a")
           

                --  >>> first (extractLinksWithText "//div[@class='tocTitle']/a")
                --  >>> first (arr ((++"/pdf") . init)) 
                -- >>> second (arr $ replace "2020")

                 -- ostatecznie wyjdą trójki ((adres URL, tytuł artykułu), tytuł rocznika)

toShadowItem :: ((String, String), String) -> ShadowItem
toShadowItem ((url, articleTitle), yearlyTitle) =
  (defaultShadowItem url title) {
    originalDate = Just date,
    itype = "periodical",
    format = Just "pdf",
    finalUrl = url
    }
  where title = "Geo Journal OOO" ++ yearlyTitle ++ " AAAAA" ++ (replace "\r\n" "" (replace "\r\n          " "" articleTitle))
        date = "202020"


-- getDate url =
--   case url =~~ "/(19[0-9][0-9]|20[0-9][0-9])/" :: Maybe [[String]] of
--     Just [[_, year]] -> year
--     otherwise -> error $ "unexpected url: " ++ url

    


main = do
    let start = "https://geojournals.pgi.gov.pl"
    
    let shadowLibrary = ShadowLibrary {logoUrl=Nothing,
                                       lname="Polish Geological Journals",
                                       abbrev="geojour",
                                       lLevel=0,
                                       webpage=start}
    extractItemsStartingFromUrl shadowLibrary start (extractRecords >>> arr toShadowItem)
